import type { D3ZoomEvent } from 'd3-zoom'
import type { FlowElements, FlowProps } from '../../types/flow'
import type {
  Connection,
  EdgeChange,
  GraphEdge,
  GraphNode,
  NodeChange,
  OnConnectStartParams,
  ViewpaneTransform,
  VueFlowStore,
} from '../../types'
import type { EdgeMouseEvent, NodeDragEvent, NodeMouseEvent } from '../../types/hooks'
declare const _default: {
  new (...args: any[]): {
    $: import('vue').ComponentInternalInstance
    $data: {}
    $props: Partial<{
      connectionLineStyle: import('vue').CSSProperties | null
      snapToGrid: boolean
      onlyRenderVisibleElements: boolean
      edgesUpdatable: boolean
      nodesDraggable: boolean
      nodesConnectable: boolean
      elementsSelectable: boolean
      selectNodesOnDrag: boolean
      panOnDrag: boolean
      zoomOnScroll: boolean
      zoomOnPinch: boolean
      panOnScroll: boolean
      zoomOnDoubleClick: boolean
      preventScrolling: boolean
      fitViewOnInit: boolean
      connectOnClick: boolean
      applyDefault: boolean
      autoConnect: boolean | import('../../types').Connector
      elevateEdgesOnSelect: boolean
    }> &
      Omit<
        Readonly<
          import('vue').ExtractPropTypes<
            __VLS_WithDefaults<
              __VLS_TypePropsToRuntimeProps<FlowProps>,
              {
                snapToGrid: undefined
                onlyRenderVisibleElements: undefined
                edgesUpdatable: undefined
                nodesConnectable: undefined
                nodesDraggable: undefined
                elementsSelectable: undefined
                selectNodesOnDrag: undefined
                preventScrolling: undefined
                zoomOnScroll: undefined
                zoomOnPinch: undefined
                zoomOnDoubleClick: undefined
                panOnScroll: undefined
                panOnDrag: undefined
                applyDefault: undefined
                fitViewOnInit: undefined
                connectOnClick: undefined
                connectionLineStyle: undefined
                autoConnect: undefined
                elevateEdgesOnSelect: undefined
              }
            >
          >
        > & {
          'onNodesChange'?: ((changes: NodeChange[]) => any) | undefined
          'onEdgesChange'?: ((changes: EdgeChange[]) => any) | undefined
          'onNodeDoubleClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onNodeClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onNodeMouseEnter'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onNodeMouseMove'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onNodeMouseLeave'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onNodeContextMenu'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onNodeDragStart'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
          'onNodeDrag'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
          'onNodeDragStop'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
          'onMiniMapNodeClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onMiniMapNodeDoubleClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onMiniMapNodeMouseEnter'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onMiniMapNodeMouseMove'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onMiniMapNodeMouseLeave'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
          'onConnect'?: ((connectionEvent: Connection) => any) | undefined
          'onConnectStart'?:
            | ((
                connectionEvent: {
                  event: MouseEvent
                } & OnConnectStartParams,
              ) => any)
            | undefined
          'onConnectStop'?: ((connectionEvent: MouseEvent) => any) | undefined
          'onConnectEnd'?: ((connectionEvent: MouseEvent) => any) | undefined
          'onPaneReady'?: ((paneEvent: VueFlowStore) => any) | undefined
          'onMove'?:
            | ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any)
            | undefined
          'onMoveStart'?:
            | ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any)
            | undefined
          'onMoveEnd'?:
            | ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any)
            | undefined
          'onSelectionDragStart'?: ((selectionEvent: NodeDragEvent) => any) | undefined
          'onSelectionDrag'?: ((selectionEvent: NodeDragEvent) => any) | undefined
          'onSelectionDragStop'?: ((selectionEvent: NodeDragEvent) => any) | undefined
          'onSelectionContextMenu'?: ((selectionEvent: { event: MouseEvent; nodes: GraphNode[] }) => any) | undefined
          'onPaneScroll'?: ((paneEvent: WheelEvent | undefined) => any) | undefined
          'onPaneClick'?: ((paneEvent: MouseEvent) => any) | undefined
          'onPaneContextMenu'?: ((paneEvent: MouseEvent) => any) | undefined
          'onEdgeContextMenu'?: ((edgeMouseEvent: EdgeMouseEvent) => any) | undefined
          'onEdgeMouseEnter'?: ((edgeMouseEvent: EdgeMouseEvent) => any) | undefined
          'onEdgeMouseMove'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
          'onEdgeMouseLeave'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
          'onEdgeDoubleClick'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
          'onEdgeClick'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
          'onEdgeUpdateStart'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
          'onEdgeUpdate'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
          'onEdgeUpdateEnd'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
          'onUpdateNodeInternals'?: ((id: string) => any) | undefined
          'onUpdate:modelValue'?: ((value: FlowElements<any>) => any) | undefined
          'onUpdate:nodes'?: ((value: GraphNode<any, any>[]) => any) | undefined
          'onUpdate:edges'?: ((value: GraphEdge<any, any>[]) => any) | undefined
        } & import('vue').VNodeProps &
          import('vue').AllowedComponentProps &
          import('vue').ComponentCustomProps,
        | 'connectionLineStyle'
        | 'snapToGrid'
        | 'onlyRenderVisibleElements'
        | 'edgesUpdatable'
        | 'nodesDraggable'
        | 'nodesConnectable'
        | 'elementsSelectable'
        | 'selectNodesOnDrag'
        | 'panOnDrag'
        | 'zoomOnScroll'
        | 'zoomOnPinch'
        | 'panOnScroll'
        | 'zoomOnDoubleClick'
        | 'preventScrolling'
        | 'fitViewOnInit'
        | 'connectOnClick'
        | 'applyDefault'
        | 'autoConnect'
        | 'elevateEdgesOnSelect'
      >
    $attrs: Record<string, unknown>
    $refs: Record<string, unknown>
    $slots: Readonly<Record<string, import('vue').Slot | undefined>>
    $root:
      | import('vue').ComponentPublicInstance<
          {},
          {},
          {},
          {},
          {},
          {},
          {},
          {},
          false,
          import('vue').ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>
        >
      | null
    $parent:
      | import('vue').ComponentPublicInstance<
          {},
          {},
          {},
          {},
          {},
          {},
          {},
          {},
          false,
          import('vue').ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>
        >
      | null
    $emit: ((event: 'nodesChange', changes: NodeChange[]) => void) &
      ((event: 'edgesChange', changes: EdgeChange[]) => void) &
      ((event: 'nodeDoubleClick', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'nodeClick', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'nodeMouseEnter', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'nodeMouseMove', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'nodeMouseLeave', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'nodeContextMenu', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'nodeDragStart', nodeDragEvent: NodeDragEvent) => void) &
      ((event: 'nodeDrag', nodeDragEvent: NodeDragEvent) => void) &
      ((event: 'nodeDragStop', nodeDragEvent: NodeDragEvent) => void) &
      ((event: 'miniMapNodeClick', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'miniMapNodeDoubleClick', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'miniMapNodeMouseEnter', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'miniMapNodeMouseMove', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'miniMapNodeMouseLeave', nodeMouseEvent: NodeMouseEvent) => void) &
      ((event: 'connect', connectionEvent: Connection) => void) &
      ((
        event: 'connectStart',
        connectionEvent: {
          event: MouseEvent
        } & OnConnectStartParams,
      ) => void) &
      ((event: 'connectStop', connectionEvent: MouseEvent) => void) &
      ((event: 'connectEnd', connectionEvent: MouseEvent) => void) &
      ((event: 'paneReady', paneEvent: VueFlowStore) => void) &
      ((
        event: 'move',
        moveEvent: {
          event: D3ZoomEvent<HTMLDivElement, any>
          flowTransform: ViewpaneTransform
        },
      ) => void) &
      ((
        event: 'moveStart',
        moveEvent: {
          event: D3ZoomEvent<HTMLDivElement, any>
          flowTransform: ViewpaneTransform
        },
      ) => void) &
      ((
        event: 'moveEnd',
        moveEvent: {
          event: D3ZoomEvent<HTMLDivElement, any>
          flowTransform: ViewpaneTransform
        },
      ) => void) &
      ((event: 'selectionDragStart', selectionEvent: NodeDragEvent) => void) &
      ((event: 'selectionDrag', selectionEvent: NodeDragEvent) => void) &
      ((event: 'selectionDragStop', selectionEvent: NodeDragEvent) => void) &
      ((
        event: 'selectionContextMenu',
        selectionEvent: {
          event: MouseEvent
          nodes: GraphNode[]
        },
      ) => void) &
      ((event: 'paneScroll', paneEvent: WheelEvent | undefined) => void) &
      ((event: 'paneClick', paneEvent: MouseEvent) => void) &
      ((event: 'paneContextMenu', paneEvent: MouseEvent) => void) &
      ((event: 'edgeContextMenu', edgeMouseEvent: EdgeMouseEvent) => void) &
      ((event: 'edgeMouseEnter', edgeMouseEvent: EdgeMouseEvent) => void) &
      ((event: 'edgeMouseMove', edgeMouseEvent: MouseEvent) => void) &
      ((event: 'edgeMouseLeave', edgeMouseEvent: MouseEvent) => void) &
      ((event: 'edgeDoubleClick', edgeMouseEvent: MouseEvent) => void) &
      ((event: 'edgeClick', edgeMouseEvent: MouseEvent) => void) &
      ((event: 'edgeUpdateStart', edgeMouseEvent: MouseEvent) => void) &
      ((event: 'edgeUpdate', edgeMouseEvent: MouseEvent) => void) &
      ((event: 'edgeUpdateEnd', edgeMouseEvent: MouseEvent) => void) &
      ((event: 'updateNodeInternals', id: string) => void) &
      ((event: 'update:modelValue', value: FlowElements<any>) => void) &
      ((event: 'update:nodes', value: GraphNode<any, any>[]) => void) &
      ((event: 'update:edges', value: GraphEdge<any, any>[]) => void)
    $el: any
    $options: import('vue').ComponentOptionsBase<
      Readonly<
        import('vue').ExtractPropTypes<
          __VLS_WithDefaults<
            __VLS_TypePropsToRuntimeProps<FlowProps>,
            {
              snapToGrid: undefined
              onlyRenderVisibleElements: undefined
              edgesUpdatable: undefined
              nodesConnectable: undefined
              nodesDraggable: undefined
              elementsSelectable: undefined
              selectNodesOnDrag: undefined
              preventScrolling: undefined
              zoomOnScroll: undefined
              zoomOnPinch: undefined
              zoomOnDoubleClick: undefined
              panOnScroll: undefined
              panOnDrag: undefined
              applyDefault: undefined
              fitViewOnInit: undefined
              connectOnClick: undefined
              connectionLineStyle: undefined
              autoConnect: undefined
              elevateEdgesOnSelect: undefined
            }
          >
        >
      > & {
        'onNodesChange'?: ((changes: NodeChange[]) => any) | undefined
        'onEdgesChange'?: ((changes: EdgeChange[]) => any) | undefined
        'onNodeDoubleClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onNodeClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onNodeMouseEnter'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onNodeMouseMove'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onNodeMouseLeave'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onNodeContextMenu'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onNodeDragStart'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
        'onNodeDrag'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
        'onNodeDragStop'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
        'onMiniMapNodeClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onMiniMapNodeDoubleClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onMiniMapNodeMouseEnter'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onMiniMapNodeMouseMove'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onMiniMapNodeMouseLeave'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
        'onConnect'?: ((connectionEvent: Connection) => any) | undefined
        'onConnectStart'?:
          | ((
              connectionEvent: {
                event: MouseEvent
              } & OnConnectStartParams,
            ) => any)
          | undefined
        'onConnectStop'?: ((connectionEvent: MouseEvent) => any) | undefined
        'onConnectEnd'?: ((connectionEvent: MouseEvent) => any) | undefined
        'onPaneReady'?: ((paneEvent: VueFlowStore) => any) | undefined
        'onMove'?: ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any) | undefined
        'onMoveStart'?:
          | ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any)
          | undefined
        'onMoveEnd'?:
          | ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any)
          | undefined
        'onSelectionDragStart'?: ((selectionEvent: NodeDragEvent) => any) | undefined
        'onSelectionDrag'?: ((selectionEvent: NodeDragEvent) => any) | undefined
        'onSelectionDragStop'?: ((selectionEvent: NodeDragEvent) => any) | undefined
        'onSelectionContextMenu'?: ((selectionEvent: { event: MouseEvent; nodes: GraphNode[] }) => any) | undefined
        'onPaneScroll'?: ((paneEvent: WheelEvent | undefined) => any) | undefined
        'onPaneClick'?: ((paneEvent: MouseEvent) => any) | undefined
        'onPaneContextMenu'?: ((paneEvent: MouseEvent) => any) | undefined
        'onEdgeContextMenu'?: ((edgeMouseEvent: EdgeMouseEvent) => any) | undefined
        'onEdgeMouseEnter'?: ((edgeMouseEvent: EdgeMouseEvent) => any) | undefined
        'onEdgeMouseMove'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
        'onEdgeMouseLeave'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
        'onEdgeDoubleClick'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
        'onEdgeClick'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
        'onEdgeUpdateStart'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
        'onEdgeUpdate'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
        'onEdgeUpdateEnd'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
        'onUpdateNodeInternals'?: ((id: string) => any) | undefined
        'onUpdate:modelValue'?: ((value: FlowElements<any>) => any) | undefined
        'onUpdate:nodes'?: ((value: GraphNode<any, any>[]) => any) | undefined
        'onUpdate:edges'?: ((value: GraphEdge<any, any>[]) => any) | undefined
      },
      {},
      unknown,
      {},
      {},
      import('vue').ComponentOptionsMixin,
      import('vue').ComponentOptionsMixin,
      {
        nodesChange: (changes: NodeChange[]) => void
      } & {
        edgesChange: (changes: EdgeChange[]) => void
      } & {
        nodeDoubleClick: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        nodeClick: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        nodeMouseEnter: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        nodeMouseMove: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        nodeMouseLeave: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        nodeContextMenu: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        nodeDragStart: (nodeDragEvent: NodeDragEvent) => void
      } & {
        nodeDrag: (nodeDragEvent: NodeDragEvent) => void
      } & {
        nodeDragStop: (nodeDragEvent: NodeDragEvent) => void
      } & {
        miniMapNodeClick: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        miniMapNodeDoubleClick: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        miniMapNodeMouseEnter: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        miniMapNodeMouseMove: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        miniMapNodeMouseLeave: (nodeMouseEvent: NodeMouseEvent) => void
      } & {
        connect: (connectionEvent: Connection) => void
      } & {
        connectStart: (
          connectionEvent: {
            event: MouseEvent
          } & OnConnectStartParams,
        ) => void
      } & {
        connectStop: (connectionEvent: MouseEvent) => void
      } & {
        connectEnd: (connectionEvent: MouseEvent) => void
      } & {
        moveStart: (moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => void
      } & {
        move: (moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => void
      } & {
        moveEnd: (moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => void
      } & {
        selectionDragStart: (selectionEvent: NodeDragEvent) => void
      } & {
        selectionDrag: (selectionEvent: NodeDragEvent) => void
      } & {
        selectionDragStop: (selectionEvent: NodeDragEvent) => void
      } & {
        selectionContextMenu: (selectionEvent: { event: MouseEvent; nodes: GraphNode[] }) => void
      } & {
        paneReady: (paneEvent: VueFlowStore) => void
      } & {
        paneScroll: (paneEvent: WheelEvent | undefined) => void
      } & {
        paneClick: (paneEvent: MouseEvent) => void
      } & {
        paneContextMenu: (paneEvent: MouseEvent) => void
      } & {
        edgeContextMenu: (edgeMouseEvent: EdgeMouseEvent) => void
      } & {
        edgeMouseEnter: (edgeMouseEvent: EdgeMouseEvent) => void
      } & {
        edgeMouseMove: (edgeMouseEvent: MouseEvent) => void
      } & {
        edgeMouseLeave: (edgeMouseEvent: MouseEvent) => void
      } & {
        edgeDoubleClick: (edgeMouseEvent: MouseEvent) => void
      } & {
        edgeClick: (edgeMouseEvent: MouseEvent) => void
      } & {
        edgeUpdateStart: (edgeMouseEvent: MouseEvent) => void
      } & {
        edgeUpdate: (edgeMouseEvent: MouseEvent) => void
      } & {
        edgeUpdateEnd: (edgeMouseEvent: MouseEvent) => void
      } & {
        updateNodeInternals: (id: string) => void
      } & {
        'update:modelValue': (value: FlowElements<any>) => void
      } & {
        'update:nodes': (value: GraphNode<any, any>[]) => void
      } & {
        'update:edges': (value: GraphEdge<any, any>[]) => void
      },
      string,
      {
        connectionLineStyle: import('vue').CSSProperties | null
        snapToGrid: boolean
        onlyRenderVisibleElements: boolean
        edgesUpdatable: boolean
        nodesDraggable: boolean
        nodesConnectable: boolean
        elementsSelectable: boolean
        selectNodesOnDrag: boolean
        panOnDrag: boolean
        zoomOnScroll: boolean
        zoomOnPinch: boolean
        panOnScroll: boolean
        zoomOnDoubleClick: boolean
        preventScrolling: boolean
        fitViewOnInit: boolean
        connectOnClick: boolean
        applyDefault: boolean
        autoConnect: boolean | import('../../types').Connector
        elevateEdgesOnSelect: boolean
      }
    > & {
      beforeCreate?: ((() => void) | (() => void)[]) | undefined
      created?: ((() => void) | (() => void)[]) | undefined
      beforeMount?: ((() => void) | (() => void)[]) | undefined
      mounted?: ((() => void) | (() => void)[]) | undefined
      beforeUpdate?: ((() => void) | (() => void)[]) | undefined
      updated?: ((() => void) | (() => void)[]) | undefined
      activated?: ((() => void) | (() => void)[]) | undefined
      deactivated?: ((() => void) | (() => void)[]) | undefined
      beforeDestroy?: ((() => void) | (() => void)[]) | undefined
      beforeUnmount?: ((() => void) | (() => void)[]) | undefined
      destroyed?: ((() => void) | (() => void)[]) | undefined
      unmounted?: ((() => void) | (() => void)[]) | undefined
      renderTracked?: (((e: import('vue').DebuggerEvent) => void) | ((e: import('vue').DebuggerEvent) => void)[]) | undefined
      renderTriggered?: (((e: import('vue').DebuggerEvent) => void) | ((e: import('vue').DebuggerEvent) => void)[]) | undefined
      errorCaptured?:
        | (
            | ((
                err: unknown,
                instance:
                  | import('vue').ComponentPublicInstance<
                      {},
                      {},
                      {},
                      {},
                      {},
                      {},
                      {},
                      {},
                      false,
                      import('vue').ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>
                    >
                  | null,
                info: string,
              ) => boolean | void)
            | ((
                err: unknown,
                instance:
                  | import('vue').ComponentPublicInstance<
                      {},
                      {},
                      {},
                      {},
                      {},
                      {},
                      {},
                      {},
                      false,
                      import('vue').ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>
                    >
                  | null,
                info: string,
              ) => boolean | void)[]
          )
        | undefined
    }
    $forceUpdate: () => void
    $nextTick: typeof import('vue').nextTick
    $watch(
      source: string | Function,
      cb: Function,
      options?: import('vue').WatchOptions<boolean> | undefined,
    ): import('vue').WatchStopHandle
  } & Readonly<
    import('vue').ExtractPropTypes<
      __VLS_WithDefaults<
        __VLS_TypePropsToRuntimeProps<FlowProps>,
        {
          snapToGrid: undefined
          onlyRenderVisibleElements: undefined
          edgesUpdatable: undefined
          nodesConnectable: undefined
          nodesDraggable: undefined
          elementsSelectable: undefined
          selectNodesOnDrag: undefined
          preventScrolling: undefined
          zoomOnScroll: undefined
          zoomOnPinch: undefined
          zoomOnDoubleClick: undefined
          panOnScroll: undefined
          panOnDrag: undefined
          applyDefault: undefined
          fitViewOnInit: undefined
          connectOnClick: undefined
          connectionLineStyle: undefined
          autoConnect: undefined
          elevateEdgesOnSelect: undefined
        }
      >
    >
  > & {
      'onNodesChange'?: ((changes: NodeChange[]) => any) | undefined
      'onEdgesChange'?: ((changes: EdgeChange[]) => any) | undefined
      'onNodeDoubleClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onNodeClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onNodeMouseEnter'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onNodeMouseMove'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onNodeMouseLeave'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onNodeContextMenu'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onNodeDragStart'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
      'onNodeDrag'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
      'onNodeDragStop'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
      'onMiniMapNodeClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onMiniMapNodeDoubleClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onMiniMapNodeMouseEnter'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onMiniMapNodeMouseMove'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onMiniMapNodeMouseLeave'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
      'onConnect'?: ((connectionEvent: Connection) => any) | undefined
      'onConnectStart'?:
        | ((
            connectionEvent: {
              event: MouseEvent
            } & OnConnectStartParams,
          ) => any)
        | undefined
      'onConnectStop'?: ((connectionEvent: MouseEvent) => any) | undefined
      'onConnectEnd'?: ((connectionEvent: MouseEvent) => any) | undefined
      'onPaneReady'?: ((paneEvent: VueFlowStore) => any) | undefined
      'onMove'?: ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any) | undefined
      'onMoveStart'?:
        | ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any)
        | undefined
      'onMoveEnd'?:
        | ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any)
        | undefined
      'onSelectionDragStart'?: ((selectionEvent: NodeDragEvent) => any) | undefined
      'onSelectionDrag'?: ((selectionEvent: NodeDragEvent) => any) | undefined
      'onSelectionDragStop'?: ((selectionEvent: NodeDragEvent) => any) | undefined
      'onSelectionContextMenu'?: ((selectionEvent: { event: MouseEvent; nodes: GraphNode[] }) => any) | undefined
      'onPaneScroll'?: ((paneEvent: WheelEvent | undefined) => any) | undefined
      'onPaneClick'?: ((paneEvent: MouseEvent) => any) | undefined
      'onPaneContextMenu'?: ((paneEvent: MouseEvent) => any) | undefined
      'onEdgeContextMenu'?: ((edgeMouseEvent: EdgeMouseEvent) => any) | undefined
      'onEdgeMouseEnter'?: ((edgeMouseEvent: EdgeMouseEvent) => any) | undefined
      'onEdgeMouseMove'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
      'onEdgeMouseLeave'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
      'onEdgeDoubleClick'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
      'onEdgeClick'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
      'onEdgeUpdateStart'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
      'onEdgeUpdate'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
      'onEdgeUpdateEnd'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
      'onUpdateNodeInternals'?: ((id: string) => any) | undefined
      'onUpdate:modelValue'?: ((value: FlowElements<any>) => any) | undefined
      'onUpdate:nodes'?: ((value: GraphNode<any, any>[]) => any) | undefined
      'onUpdate:edges'?: ((value: GraphEdge<any, any>[]) => any) | undefined
    } & import('vue').ShallowUnwrapRef<{}> & {} & import('vue').ComponentCustomProperties
  __isFragment?: undefined
  __isTeleport?: undefined
  __isSuspense?: undefined
} & import('vue').ComponentOptionsBase<
  Readonly<
    import('vue').ExtractPropTypes<
      __VLS_WithDefaults<
        __VLS_TypePropsToRuntimeProps<FlowProps>,
        {
          snapToGrid: undefined
          onlyRenderVisibleElements: undefined
          edgesUpdatable: undefined
          nodesConnectable: undefined
          nodesDraggable: undefined
          elementsSelectable: undefined
          selectNodesOnDrag: undefined
          preventScrolling: undefined
          zoomOnScroll: undefined
          zoomOnPinch: undefined
          zoomOnDoubleClick: undefined
          panOnScroll: undefined
          panOnDrag: undefined
          applyDefault: undefined
          fitViewOnInit: undefined
          connectOnClick: undefined
          connectionLineStyle: undefined
          autoConnect: undefined
          elevateEdgesOnSelect: undefined
        }
      >
    >
  > & {
    'onNodesChange'?: ((changes: NodeChange[]) => any) | undefined
    'onEdgesChange'?: ((changes: EdgeChange[]) => any) | undefined
    'onNodeDoubleClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onNodeClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onNodeMouseEnter'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onNodeMouseMove'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onNodeMouseLeave'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onNodeContextMenu'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onNodeDragStart'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
    'onNodeDrag'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
    'onNodeDragStop'?: ((nodeDragEvent: NodeDragEvent) => any) | undefined
    'onMiniMapNodeClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onMiniMapNodeDoubleClick'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onMiniMapNodeMouseEnter'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onMiniMapNodeMouseMove'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onMiniMapNodeMouseLeave'?: ((nodeMouseEvent: NodeMouseEvent) => any) | undefined
    'onConnect'?: ((connectionEvent: Connection) => any) | undefined
    'onConnectStart'?:
      | ((
          connectionEvent: {
            event: MouseEvent
          } & OnConnectStartParams,
        ) => any)
      | undefined
    'onConnectStop'?: ((connectionEvent: MouseEvent) => any) | undefined
    'onConnectEnd'?: ((connectionEvent: MouseEvent) => any) | undefined
    'onPaneReady'?: ((paneEvent: VueFlowStore) => any) | undefined
    'onMove'?: ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any) | undefined
    'onMoveStart'?:
      | ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any)
      | undefined
    'onMoveEnd'?: ((moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => any) | undefined
    'onSelectionDragStart'?: ((selectionEvent: NodeDragEvent) => any) | undefined
    'onSelectionDrag'?: ((selectionEvent: NodeDragEvent) => any) | undefined
    'onSelectionDragStop'?: ((selectionEvent: NodeDragEvent) => any) | undefined
    'onSelectionContextMenu'?: ((selectionEvent: { event: MouseEvent; nodes: GraphNode[] }) => any) | undefined
    'onPaneScroll'?: ((paneEvent: WheelEvent | undefined) => any) | undefined
    'onPaneClick'?: ((paneEvent: MouseEvent) => any) | undefined
    'onPaneContextMenu'?: ((paneEvent: MouseEvent) => any) | undefined
    'onEdgeContextMenu'?: ((edgeMouseEvent: EdgeMouseEvent) => any) | undefined
    'onEdgeMouseEnter'?: ((edgeMouseEvent: EdgeMouseEvent) => any) | undefined
    'onEdgeMouseMove'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
    'onEdgeMouseLeave'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
    'onEdgeDoubleClick'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
    'onEdgeClick'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
    'onEdgeUpdateStart'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
    'onEdgeUpdate'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
    'onEdgeUpdateEnd'?: ((edgeMouseEvent: MouseEvent) => any) | undefined
    'onUpdateNodeInternals'?: ((id: string) => any) | undefined
    'onUpdate:modelValue'?: ((value: FlowElements<any>) => any) | undefined
    'onUpdate:nodes'?: ((value: GraphNode<any, any>[]) => any) | undefined
    'onUpdate:edges'?: ((value: GraphEdge<any, any>[]) => any) | undefined
  },
  {},
  unknown,
  {},
  {},
  import('vue').ComponentOptionsMixin,
  import('vue').ComponentOptionsMixin,
  {
    nodesChange: (changes: NodeChange[]) => void
  } & {
    edgesChange: (changes: EdgeChange[]) => void
  } & {
    nodeDoubleClick: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    nodeClick: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    nodeMouseEnter: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    nodeMouseMove: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    nodeMouseLeave: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    nodeContextMenu: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    nodeDragStart: (nodeDragEvent: NodeDragEvent) => void
  } & {
    nodeDrag: (nodeDragEvent: NodeDragEvent) => void
  } & {
    nodeDragStop: (nodeDragEvent: NodeDragEvent) => void
  } & {
    miniMapNodeClick: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    miniMapNodeDoubleClick: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    miniMapNodeMouseEnter: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    miniMapNodeMouseMove: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    miniMapNodeMouseLeave: (nodeMouseEvent: NodeMouseEvent) => void
  } & {
    connect: (connectionEvent: Connection) => void
  } & {
    connectStart: (
      connectionEvent: {
        event: MouseEvent
      } & OnConnectStartParams,
    ) => void
  } & {
    connectStop: (connectionEvent: MouseEvent) => void
  } & {
    connectEnd: (connectionEvent: MouseEvent) => void
  } & {
    moveStart: (moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => void
  } & {
    move: (moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => void
  } & {
    moveEnd: (moveEvent: { event: D3ZoomEvent<HTMLDivElement, any>; flowTransform: ViewpaneTransform }) => void
  } & {
    selectionDragStart: (selectionEvent: NodeDragEvent) => void
  } & {
    selectionDrag: (selectionEvent: NodeDragEvent) => void
  } & {
    selectionDragStop: (selectionEvent: NodeDragEvent) => void
  } & {
    selectionContextMenu: (selectionEvent: { event: MouseEvent; nodes: GraphNode[] }) => void
  } & {
    paneReady: (paneEvent: VueFlowStore) => void
  } & {
    paneScroll: (paneEvent: WheelEvent | undefined) => void
  } & {
    paneClick: (paneEvent: MouseEvent) => void
  } & {
    paneContextMenu: (paneEvent: MouseEvent) => void
  } & {
    edgeContextMenu: (edgeMouseEvent: EdgeMouseEvent) => void
  } & {
    edgeMouseEnter: (edgeMouseEvent: EdgeMouseEvent) => void
  } & {
    edgeMouseMove: (edgeMouseEvent: MouseEvent) => void
  } & {
    edgeMouseLeave: (edgeMouseEvent: MouseEvent) => void
  } & {
    edgeDoubleClick: (edgeMouseEvent: MouseEvent) => void
  } & {
    edgeClick: (edgeMouseEvent: MouseEvent) => void
  } & {
    edgeUpdateStart: (edgeMouseEvent: MouseEvent) => void
  } & {
    edgeUpdate: (edgeMouseEvent: MouseEvent) => void
  } & {
    edgeUpdateEnd: (edgeMouseEvent: MouseEvent) => void
  } & {
    updateNodeInternals: (id: string) => void
  } & {
    'update:modelValue': (value: FlowElements<any>) => void
  } & {
    'update:nodes': (value: GraphNode<any, any>[]) => void
  } & {
    'update:edges': (value: GraphEdge<any, any>[]) => void
  },
  string,
  {
    connectionLineStyle: import('vue').CSSProperties | null
    snapToGrid: boolean
    onlyRenderVisibleElements: boolean
    edgesUpdatable: boolean
    nodesDraggable: boolean
    nodesConnectable: boolean
    elementsSelectable: boolean
    selectNodesOnDrag: boolean
    panOnDrag: boolean
    zoomOnScroll: boolean
    zoomOnPinch: boolean
    panOnScroll: boolean
    zoomOnDoubleClick: boolean
    preventScrolling: boolean
    fitViewOnInit: boolean
    connectOnClick: boolean
    applyDefault: boolean
    autoConnect: boolean | import('../../types').Connector
    elevateEdgesOnSelect: boolean
  }
> &
  import('vue').VNodeProps &
  import('vue').AllowedComponentProps &
  import('vue').ComponentCustomProps &
  (new () => {
    $slots: Record<string, {}> &
      Record<string, {}> & {
        'connection-line': {}
        'zoom-pane': {}
        'default': {}
      }
  })
export default _default
declare type __VLS_NonUndefinedable<T> = T extends undefined ? never : T
declare type __VLS_TypePropsToRuntimeProps<T> = {
  [K in keyof T]-?: {} extends Pick<T, K>
    ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>
      }
    : {
        type: import('vue').PropType<T[K]>
        required: true
      }
}
declare type __VLS_WithDefaults<P, D> = {
  [K in keyof Pick<P, keyof P>]: K extends keyof D
    ? P[K] & {
        default: D[K]
      }
    : P[K]
}
